# Queries

## Get entries

<mark style="color:blue;">`GET`</mark> `https://api.echo3D.com/query?key=<API_KEY>&email=<EMAIL>&userKey=<USER_KEY>`

This query allows you to retrieve a data set of entries associated with your API key.

#### Query Parameters

| Name                                      | Type   | Description                                                                                                                                                 |
| ----------------------------------------- | ------ | ----------------------------------------------------------------------------------------------------------------------------------------------------------- |
| key<mark style="color:red;">\*</mark>     | string | Your API key.                                                                                                                                               |
| secKey<mark style="color:red;">\*</mark>  | string | Your Secret key. You can disable need to include this key in the [Security page](/web-console/manage-pages/collections-and-sharing/security.md#secret-key). |
| email<mark style="color:red;">\*</mark>   | string | Your email address                                                                                                                                          |
| userKey<mark style="color:red;">\*</mark> | string | Your authentication key                                                                                                                                     |

{% tabs %}
{% tab title="200 Set of entries successfully retrieved." %}

```json
{
  "apiKey": "<API_KEY>",
  "db": {
    "b02cc2f0-3050-4f3a-999e-c8e8be9d3b5b": {
      "id": "b02cc2f0-3050-4f3a-999e-c8e8be9d3b5b",
      "target": {
        "id": "df54c477-8eeb-4530-b989-4cb3cdcd6512",
        "type": "BRICK_TARGET",
        "holograms": [
          "ada1dfd6-0f0e-4606-bde6-fc88a0610466"
        ]
      },
      "hologram": {
        "filename": "Skyscraper.obj",
        "storageID": "d686a655-e800-430d-bfd2-e38cdfb0c9e9",
        "textureFilenames": [
          "Skyscraper_BaseColor.png"
        ],
        "textureStorageIDs": [
          "f9b43711-cf79-44e5-90c5-ac781c8d9288"
        ],
        "materialFilename": "Skyscraper.mtl",
        "materialStorageID": "891d0b32-4f4b-4f7d-a2e2-d5922611928d",
        "id": "ada1dfd6-0f0e-4606-bde6-fc88a0610466",
        "type": "MODEL_HOLOGRAM",
        "targetID": "df54c477-8eeb-4530-b989-4cb3cdcd6512"
      },
      "sdks": [
        true,
        true,
        false,
        true,
        false,
        false,
        false,
        true,
        true
      ],
      "additionalData": {
        "qrWebXRStorageID": "018b9e20-3b8e-47f8-a19c-eca8dde46137",
        "vuforiaHologramStorageID": "7068cd74-6c9f-4106-9326-585c56fa4475",
        "glbHologramStorageID": "d686a655-e800-430d-bfd2-e38cdfb0c9e9.glb",
        "source": "Skyscraper by Poly by Google, CC-BY, https://poly.google.com/view/dIsZyy2FUY-",
        "qrARjsTargetStorageID": "e7f058d5-5b66-4f50-8cdd-89f057e8070c",
        "qrARjsStorageID": "7cc6adca-ded1-4a46-a289-c07c07cb2f5c",
        "vuforiaHologramStorageFilename": "Skyscraper.h",
        "qrARjsMarkerStorageID": "5de99f4d-9602-45f0-b5ce-7ef53541cb18",
        "glbHologramStorageFilename": "Skyscraper.glb"
      }
    }
  }
}
```

{% endtab %}

{% tab title="404 Could not find the API key." %}

```
Key '<API_KEY>' not found!
```

{% endtab %}
{% endtabs %}

## Get a specific entry

<mark style="color:blue;">`GET`</mark> `https://api.echo3D.com/query?key=<API_KEY>&email=<EMAIL>&userKey=<USER_KEY>&entry=<ENTRY_ID>`

This query allows you to retrieve a specific entry.

#### Query Parameters

| Name                                      | Type   | Description                                                                                                                             |
| ----------------------------------------- | ------ | --------------------------------------------------------------------------------------------------------------------------------------- |
| key<mark style="color:red;">\*</mark>     | string | Your API key.                                                                                                                           |
| entry<mark style="color:red;">\*</mark>   | string | A specific entry ID.                                                                                                                    |
| secKey                                    | string | Your Secret key. Only if enabled through the [Security page](/web-console/manage-pages/collections-and-sharing/security.md#secret-key). |
| email<mark style="color:red;">\*</mark>   | string | Your email address                                                                                                                      |
| userKey<mark style="color:red;">\*</mark> | string | Your authentication key                                                                                                                 |

{% tabs %}
{% tab title="200 " %}

```json
{
  "apiKey": "<API_KEY>",
  "db": {
    "b02cc2f0-3050-4f3a-999e-c8e8be9d3b5b": {
      "id": "b02cc2f0-3050-4f3a-999e-c8e8be9d3b5b",
      "target": {
        "id": "df54c477-8eeb-4530-b989-4cb3cdcd6512",
        "type": "BRICK_TARGET",
        "holograms": [
          "ada1dfd6-0f0e-4606-bde6-fc88a0610466"
        ]
      },
      "hologram": {
        "filename": "Skyscraper.obj",
        "storageID": "d686a655-e800-430d-bfd2-e38cdfb0c9e9",
        "textureFilenames": [
          "Skyscraper_BaseColor.png"
        ],
        "textureStorageIDs": [
          "f9b43711-cf79-44e5-90c5-ac781c8d9288"
        ],
        "materialFilename": "Skyscraper.mtl",
        "materialStorageID": "891d0b32-4f4b-4f7d-a2e2-d5922611928d",
        "id": "ada1dfd6-0f0e-4606-bde6-fc88a0610466",
        "type": "MODEL_HOLOGRAM",
        "targetID": "df54c477-8eeb-4530-b989-4cb3cdcd6512"
      },
      "sdks": [
        true,
        true,
        false,
        true,
        false,
        false,
        false,
        true,
        true
      ],
      "additionalData": {
        "qrWebXRStorageID": "018b9e20-3b8e-47f8-a19c-eca8dde46137",
        "vuforiaHologramStorageID": "7068cd74-6c9f-4106-9326-585c56fa4475",
        "glbHologramStorageID": "d686a655-e800-430d-bfd2-e38cdfb0c9e9.glb",
        "source": "Skyscraper by Poly by Google, CC-BY, https://poly.google.com/view/dIsZyy2FUY-",
        "qrARjsTargetStorageID": "e7f058d5-5b66-4f50-8cdd-89f057e8070c",
        "qrARjsStorageID": "7cc6adca-ded1-4a46-a289-c07c07cb2f5c",
        "vuforiaHologramStorageFilename": "Skyscraper.h",
        "qrARjsMarkerStorageID": "5de99f4d-9602-45f0-b5ce-7ef53541cb18",
        "glbHologramStorageFilename": "Skyscraper.glb"
      }
    }
  }
}
```

{% endtab %}

{% tab title="400 " %}

```
Entry ID '<ENTRY_ID>' not associated with key '<API_KEY>'.
```

{% endtab %}
{% endtabs %}

## Get specific entries

<mark style="color:blue;">`GET`</mark> `https://api.echo3D.com/query?key=<API_KEY>&email=<EMAIL>&userKey=<USER_KEY>&entries=<ENTRY_ID1>,<ENTRY_ID2>,..`

This query allows you to retrieve specific entries.

#### Query Parameters

| Name                                      | Type   | Description                                                                                                                             |
| ----------------------------------------- | ------ | --------------------------------------------------------------------------------------------------------------------------------------- |
| key<mark style="color:red;">\*</mark>     | string | Your API key.                                                                                                                           |
| entries<mark style="color:red;">\*</mark> | string | Comma-separated list of entry IDs without spaces                                                                                        |
| secKey                                    | String | Your Secret key. Only if enabled through the [Security page](/web-console/manage-pages/collections-and-sharing/security.md#secret-key). |
| email<mark style="color:red;">\*</mark>   | string | Your email address                                                                                                                      |
| userKey<mark style="color:red;">\*</mark> | string | Your authentication key                                                                                                                 |

{% tabs %}
{% tab title="200: OK " %}

```json
{
  "apiKey": "<API_KEY>",
  "db": {
    "b02cc2f0-3050-4f3a-999e-c8e8be9d3b5b": {
      "id": "b02cc2f0-3050-4f3a-999e-c8e8be9d3b5b",
      "target": {
        "id": "df54c477-8eeb-4530-b989-4cb3cdcd6512",
        "type": "<TYPE>",
        "holograms": [
          "ada1dfd6-0f0e-4606-bde6-fc88a0610466"
        ]
      },
      "hologram": {
        "filename": "Skyscraper.obj",
        "storageID": "d686a655-e800-430d-bfd2-e38cdfb0c9e9",
        "textureFilenames": [
          "Skyscraper_BaseColor.png"
        ],
        "textureStorageIDs": [
          "f9b43711-cf79-44e5-90c5-ac781c8d9288"
        ],
        "materialFilename": "Skyscraper.mtl",
        "materialStorageID": "891d0b32-4f4b-4f7d-a2e2-d5922611928d",
        "id": "ada1dfd6-0f0e-4606-bde6-fc88a0610466",
        "type": "MODEL_HOLOGRAM",
        "targetID": "df54c477-8eeb-4530-b989-4cb3cdcd6512"
      },
      "sdks": [
        true,
        true,
        false,
        true,
        false,
        false,
        false,
        true,
        true
      ],
      "additionalData": {
        "vuforiaHologramStorageID": "7068cd74-6c9f-4106-9326-585c56fa4475",
        "glbHologramStorageID": "d686a655-e800-430d-bfd2-e38cdfb0c9e9.glb",
        "source": "Skyscraper by Poly by Google, CC-BY, https://poly.google.com/view/dIsZyy2FUY-",
        "qrARjsTargetStorageID": "e7f058d5-5b66-4f50-8cdd-89f057e8070c",
        "qrARjsStorageID": "7cc6adca-ded1-4a46-a289-c07c07cb2f5c",
        "vuforiaHologramStorageFilename": "Skyscraper.h",
        "qrARjsMarkerStorageID": "5de99f4d-9602-45f0-b5ce-7ef53541cb18",
        "glbHologramStorageFilename": "Skyscraper.glb"
      }
    }, "b02cc2f0-3050-4f3a-111e-c8e8b2413b5b": {
      "id": "b02cc2f0-3050-4f3a-999e-c8e8be9d3b5b",
      "target": {
        "id": "df54c477-8eeb-4530-b989-4cb3cdcd6512",
        "type": "<TYPE>",
        "holograms": [
          "ada1dfd6-0f0e-4606-bde6-fc88a0610466"
        ]
      },
      "hologram": {
        "filename": "Skyscraper.obj",
        "storageID": "d686a655-e800-430d-bfd2-e38cdfb0c9e9",
        "textureFilenames": [
          "Skyscraper_BaseColor.png"
        ],
        "textureStorageIDs": [
          "f9b43711-cf79-44e5-90c5-ac781c8d9288"
        ],
        "materialFilename": "Skyscraper.mtl",
        "materialStorageID": "891d0b32-4f4b-4f7d-a2e2-d5922611928d",
        "id": "ada1dfd6-0f0e-4606-bde6-fc88a0610466",
        "type": "MODEL_HOLOGRAM",
        "targetID": "df54c477-8eeb-4530-b989-4cb3cdcd6512"
      },
      "sdks": [
        true,
        true,
        false,
        true,
        false,
        false,
        false,
        true,
        true
      ],
      "additionalData": {
        "vuforiaHologramStorageID": "7068cd74-6c9f-4106-9326-585c56fa4475",
        "glbHologramStorageID": "d686a655-e800-430d-bfd2-e38cdfb0c9e9.glb",
        "source": "Skyscraper by Poly by Google, CC-BY, https://poly.google.com/view/dIsZyy2FUY-",
        "qrARjsTargetStorageID": "e7f058d5-5b66-4f50-8cdd-89f057e8070c",
        "qrARjsStorageID": "7cc6adca-ded1-4a46-a289-c07c07cb2f5c",
        "vuforiaHologramStorageFilename": "Skyscraper.h",
        "qrARjsMarkerStorageID": "5de99f4d-9602-45f0-b5ce-7ef53541cb18",
        "glbHologramStorageFilename": "Skyscraper.glb"
      }
    }
  }
}
```

{% endtab %}

{% tab title="400: Bad Request " %}

```javascript
Entry ID '<ENTRY_ID1>' not associated with key '<API_KEY>'.
```

{% endtab %}
{% endtabs %}

## &#x20;Get entries based on file

<mark style="color:blue;">`GET`</mark> `https://api.echo3D.com/query?key=<API_KEY>&email=<EMAIL>&userKey=<USER_KEY>&filename=<FILENAME>`

This query allows you to retrieve entries that contain a specific file.

#### Query Parameters

| Name                                       | Type   | Description                                                                                                                             |
| ------------------------------------------ | ------ | --------------------------------------------------------------------------------------------------------------------------------------- |
| key<mark style="color:red;">\*</mark>      | string | Your API key.                                                                                                                           |
| filename<mark style="color:red;">\*</mark> | string | A file name, e.g. `myfile.obj`.                                                                                                         |
| secKey                                     | string | Your Secret key. Only if enabled through the [Security page](/web-console/manage-pages/collections-and-sharing/security.md#secret-key). |
| email<mark style="color:red;">\*</mark>    | string | Your email address                                                                                                                      |
| userKey<mark style="color:red;">\*</mark>  | string | Your authentication key                                                                                                                 |

{% tabs %}
{% tab title="200 Set of entries successfully retrieved." %}

```json
{
  "apiKey": "<API_KEY>",
  "db": {
    "b02cc2f0-3050-4f3a-999e-c8e8be9d3b5b": {
      "id": "b02cc2f0-3050-4f3a-999e-c8e8be9d3b5b",
      "target": {
        "id": "df54c477-8eeb-4530-b989-4cb3cdcd6512",
        "type": "BRICK_TARGET",
        "holograms": [
          "ada1dfd6-0f0e-4606-bde6-fc88a0610466"
        ]
      },
      "hologram": {
        "filename": "<FILENAME>",
        "storageID": "d686a655-e800-430d-bfd2-e38cdfb0c9e9",
        "textureFilenames": [
          "Skyscraper_BaseColor.png"
        ],
        "textureStorageIDs": [
          "f9b43711-cf79-44e5-90c5-ac781c8d9288"
        ],
        "materialFilename": "Skyscraper.mtl",
        "materialStorageID": "891d0b32-4f4b-4f7d-a2e2-d5922611928d",
        "id": "ada1dfd6-0f0e-4606-bde6-fc88a0610466",
        "type": "MODEL_HOLOGRAM",
        "targetID": "df54c477-8eeb-4530-b989-4cb3cdcd6512"
      },
      "sdks": [
        true,
        true,
        false,
        true,
        false,
        false,
        false,
        true,
        true
      ],
      "additionalData": {
        "qrWebXRStorageID": "018b9e20-3b8e-47f8-a19c-eca8dde46137",
        "vuforiaHologramStorageID": "7068cd74-6c9f-4106-9326-585c56fa4475",
        "glbHologramStorageID": "d686a655-e800-430d-bfd2-e38cdfb0c9e9.glb",
        "source": "Skyscraper by Poly by Google, CC-BY, https://poly.google.com/view/dIsZyy2FUY-",
        "qrARjsTargetStorageID": "e7f058d5-5b66-4f50-8cdd-89f057e8070c",
        "qrARjsStorageID": "7cc6adca-ded1-4a46-a289-c07c07cb2f5c",
        "vuforiaHologramStorageFilename": "Skyscraper.h",
        "qrARjsMarkerStorageID": "5de99f4d-9602-45f0-b5ce-7ef53541cb18",
        "glbHologramStorageFilename": "Skyscraper.glb"
      }
    }
  }
}
```

{% endtab %}

{% tab title="400 " %}

```
No entries found containing a file named '<FILENAME>' associated with key '<API_KEY>'.
```

{% endtab %}
{% endtabs %}

## Get entries based on data

<mark style="color:blue;">`GET`</mark> `https://api.echo3D.com/query?key=<API_KEY>&email=<EMAIL>&userKey=<USER_KEY>&data=<DATA>&value=<VALUE>`

This query allows you to retrieve entries that contain a specific data key and value.

#### Query Parameters

| Name                                      | Type   | Description                                                                                                                             |
| ----------------------------------------- | ------ | --------------------------------------------------------------------------------------------------------------------------------------- |
| key<mark style="color:red;">\*</mark>     | string | Your API key.                                                                                                                           |
| data<mark style="color:red;">\*</mark>    | string | A data key, e.g. `scale`.                                                                                                               |
| value                                     | string | A data value, e.g. `2`.                                                                                                                 |
| secKey                                    | string | Your Secret key. Only if enabled through the [Security page](/web-console/manage-pages/collections-and-sharing/security.md#secret-key). |
| email<mark style="color:red;">\*</mark>   | string | Your email address                                                                                                                      |
| userKey<mark style="color:red;">\*</mark> | string | Your authentication key                                                                                                                 |

{% tabs %}
{% tab title="200 " %}

```json
{
  "apiKey": "<API_KEY>",
  "db": {
    "b02cc2f0-3050-4f3a-999e-c8e8be9d3b5b": {
      "id": "b02cc2f0-3050-4f3a-999e-c8e8be9d3b5b",
      "target": {
        "id": "df54c477-8eeb-4530-b989-4cb3cdcd6512",
        "type": "BRICK_TARGET",
        "holograms": [
          "ada1dfd6-0f0e-4606-bde6-fc88a0610466"
        ]
      },
      "hologram": {
        "filename": "Skyscraper.obj",
        "storageID": "d686a655-e800-430d-bfd2-e38cdfb0c9e9",
        "textureFilenames": [
          "Skyscraper_BaseColor.png"
        ],
        "textureStorageIDs": [
          "f9b43711-cf79-44e5-90c5-ac781c8d9288"
        ],
        "materialFilename": "Skyscraper.mtl",
        "materialStorageID": "891d0b32-4f4b-4f7d-a2e2-d5922611928d",
        "id": "ada1dfd6-0f0e-4606-bde6-fc88a0610466",
        "type": "MODEL_HOLOGRAM",
        "targetID": "df54c477-8eeb-4530-b989-4cb3cdcd6512"
      },
      "sdks": [
        true,
        true,
        false,
        true,
        false,
        false,
        false,
        true,
        true
      ],
      "additionalData": {
        "<DATA>": "<VALUE>",
        "vuforiaHologramStorageID": "7068cd74-6c9f-4106-9326-585c56fa4475",
        "glbHologramStorageID": "d686a655-e800-430d-bfd2-e38cdfb0c9e9.glb",
        "source": "Skyscraper by Poly by Google, CC-BY, https://poly.google.com/view/dIsZyy2FUY-",
        "qrARjsTargetStorageID": "e7f058d5-5b66-4f50-8cdd-89f057e8070c",
        "qrARjsStorageID": "7cc6adca-ded1-4a46-a289-c07c07cb2f5c",
        "vuforiaHologramStorageFilename": "Skyscraper.h",
        "qrARjsMarkerStorageID": "5de99f4d-9602-45f0-b5ce-7ef53541cb18",
        "glbHologramStorageFilename": "Skyscraper.glb"
      }
    }
  }
}
```

{% endtab %}

{% tab title="400 " %}

```
Entries with <data, value> pair '<DATA>,<VALUE>' not associated with key '<API_KEY>'.
```

{% endtab %}
{% endtabs %}

## Get entries based on tags

<mark style="color:blue;">`GET`</mark> `https://api.echo3D.com/query?key=<API_KEY>&email=<EMAIL>&userKey=<USER_KEY>&tags=<TAG1>,<TAG2>,..`

This query allows you to retrieve entries based on the default ‘tags’ metadata. This query will return any asset whose 'tags' metadata matches *any* of the query parameter filters.&#x20;

#### Query Parameters

| Name                                      | Type   | Description                                                                                                                             |
| ----------------------------------------- | ------ | --------------------------------------------------------------------------------------------------------------------------------------- |
| key<mark style="color:red;">\*</mark>     | string | Your API key.                                                                                                                           |
| tags<mark style="color:red;">\*</mark>    | string | Comma-separated list of tags without spaces                                                                                             |
| secKey                                    | string | Your Secret key. Only if enabled through the [Security page](/web-console/manage-pages/collections-and-sharing/security.md#secret-key). |
| email<mark style="color:red;">\*</mark>   | string | Your email address                                                                                                                      |
| userKey<mark style="color:red;">\*</mark> | string | Your authentication key                                                                                                                 |

{% tabs %}
{% tab title="200: OK " %}

```json
{
  "apiKey": "<API_KEY>",
  "db": {
    "b02cc2f0-3050-4f3a-999e-c8e8be9d3b5b": {
      "id": "b02cc2f0-3050-4f3a-999e-c8e8be9d3b5b",
      "target": {
        "id": "df54c477-8eeb-4530-b989-4cb3cdcd6512",
        "type": "BRICK_TARGET",
        "holograms": [
          "ada1dfd6-0f0e-4606-bde6-fc88a0610466"
        ]
      },
      "hologram": {
        "filename": "Skyscraper.obj",
        "storageID": "d686a655-e800-430d-bfd2-e38cdfb0c9e9",
        "textureFilenames": [
          "Skyscraper_BaseColor.png"
        ],
        "textureStorageIDs": [
          "f9b43711-cf79-44e5-90c5-ac781c8d9288"
        ],
        "materialFilename": "Skyscraper.mtl",
        "materialStorageID": "891d0b32-4f4b-4f7d-a2e2-d5922611928d",
        "id": "ada1dfd6-0f0e-4606-bde6-fc88a0610466",
        "type": "MODEL_HOLOGRAM",
        "targetID": "df54c477-8eeb-4530-b989-4cb3cdcd6512"
      },
      "sdks": [
        true,
        true,
        false,
        true,
        false,
        false,
        false,
        true,
        true
      ],
      "additionalData": {
        "tags": "<TAG1>",
        "vuforiaHologramStorageID": "7068cd74-6c9f-4106-9326-585c56fa4475",
        "glbHologramStorageID": "d686a655-e800-430d-bfd2-e38cdfb0c9e9.glb",
        "source": "Skyscraper by Poly by Google, CC-BY, https://poly.google.com/view/dIsZyy2FUY-",
        "qrARjsTargetStorageID": "e7f058d5-5b66-4f50-8cdd-89f057e8070c",
        "qrARjsStorageID": "7cc6adca-ded1-4a46-a289-c07c07cb2f5c",
        "vuforiaHologramStorageFilename": "Skyscraper.h",
        "qrARjsMarkerStorageID": "5de99f4d-9602-45f0-b5ce-7ef53541cb18",
        "glbHologramStorageFilename": "Skyscraper.glb"
      }
    }
  }
}
```

{% endtab %}

{% tab title="400: Bad Request " %}

```javascript
{}
```

{% endtab %}
{% endtabs %}

## Get entries based on filters

<mark style="color:blue;">`GET`</mark> `https://api.echo3D.com/query?key=<API_KEY>&email=<EMAIL>&userKey=<USER_KEY>&filters=<filter1>,<filter2>,<filter3>,...`

This query allows you to retrieve entries based on the default ‘tags’ metadata. This query will return any asset whose 'tags' metadata matches *all* of the query parameter filters.&#x20;

#### Query Parameters

| Name                                      | Type   | Description                                                                                                                             |
| ----------------------------------------- | ------ | --------------------------------------------------------------------------------------------------------------------------------------- |
| key<mark style="color:red;">\*</mark>     | String | Your API key.                                                                                                                           |
| filters<mark style="color:red;">\*</mark> | String | Comma-separated list of filters without spaces                                                                                          |
| secKey                                    | String | Your Secret key. Only if enabled through the [Security page](/web-console/manage-pages/collections-and-sharing/security.md#secret-key). |
| email<mark style="color:red;">\*</mark>   | string | Your email address                                                                                                                      |
| userKey<mark style="color:red;">\*</mark> | string | Your authentication key                                                                                                                 |

## Get entries based on type

<mark style="color:blue;">`GET`</mark> `https://api.echo3D.com/query?key=<API_KEY>&email=<EMAIL>&userKey=<USER_KEY>&type=<TYPE>`

This query allows you to retrieve entries that contain a specific type of hologram or target.

#### Query Parameters

| Name                                      | Type   | Description                                                                                                                                         |
| ----------------------------------------- | ------ | --------------------------------------------------------------------------------------------------------------------------------------------------- |
| key<mark style="color:red;">\*</mark>     | string | Your API key.                                                                                                                                       |
| type<mark style="color:red;">\*</mark>    | string | A type of hologram or target. Options: `MODEL_HOLOGRAM`, `VIDEO_HOLOGRAM`, `IMAGE_HOLOGRAM`,`BRICK_TARGET`, `GEOLOCATION_TARGET`, or `IMAGE_TARGET` |
| secKey                                    | string | Your Secret key. Only if enabled through the [Security page](/web-console/manage-pages/collections-and-sharing/security.md#secret-key).             |
| email<mark style="color:red;">\*</mark>   | string | Your email address                                                                                                                                  |
| userKey<mark style="color:red;">\*</mark> | string | Your authentication key                                                                                                                             |

{% tabs %}
{% tab title="200 " %}

```json
{
  "apiKey": "<API_KEY>",
  "db": {
    "b02cc2f0-3050-4f3a-999e-c8e8be9d3b5b": {
      "id": "b02cc2f0-3050-4f3a-999e-c8e8be9d3b5b",
      "target": {
        "id": "df54c477-8eeb-4530-b989-4cb3cdcd6512",
        "type": "<TYPE>",
        "holograms": [
          "ada1dfd6-0f0e-4606-bde6-fc88a0610466"
        ]
      },
      "hologram": {
        "filename": "Skyscraper.obj",
        "storageID": "d686a655-e800-430d-bfd2-e38cdfb0c9e9",
        "textureFilenames": [
          "Skyscraper_BaseColor.png"
        ],
        "textureStorageIDs": [
          "f9b43711-cf79-44e5-90c5-ac781c8d9288"
        ],
        "materialFilename": "Skyscraper.mtl",
        "materialStorageID": "891d0b32-4f4b-4f7d-a2e2-d5922611928d",
        "id": "ada1dfd6-0f0e-4606-bde6-fc88a0610466",
        "type": "MODEL_HOLOGRAM",
        "targetID": "df54c477-8eeb-4530-b989-4cb3cdcd6512"
      },
      "sdks": [
        true,
        true,
        false,
        true,
        false,
        false,
        false,
        true,
        true
      ],
      "additionalData": {
        "vuforiaHologramStorageID": "7068cd74-6c9f-4106-9326-585c56fa4475",
        "glbHologramStorageID": "d686a655-e800-430d-bfd2-e38cdfb0c9e9.glb",
        "source": "Skyscraper by Poly by Google, CC-BY, https://poly.google.com/view/dIsZyy2FUY-",
        "qrARjsTargetStorageID": "e7f058d5-5b66-4f50-8cdd-89f057e8070c",
        "qrARjsStorageID": "7cc6adca-ded1-4a46-a289-c07c07cb2f5c",
        "vuforiaHologramStorageFilename": "Skyscraper.h",
        "qrARjsMarkerStorageID": "5de99f4d-9602-45f0-b5ce-7ef53541cb18",
        "glbHologramStorageFilename": "Skyscraper.glb"
      }
    }
  }
}
```

{% endtab %}

{% tab title="400 " %}

```
Entry type '<TYPE>' not associated with key '<API_KEY>'.
```

{% endtab %}
{% endtabs %}

## Get entries based on timestamp

<mark style="color:blue;">`GET`</mark> `https://api.echo3D.com/query?key=<API_KEY>&email=<EMAIL>&secKey=<SEC_KEY>&userKey=<USER_KEY>&fromTimestamp=<FROM_TIMESTAMP>&toTimestamp=<TO_TIMESTAMP>`

This query allows you to retrieve entries that were uploaded given timestamp parameters. The `fromTimestamp` parameter will return assets that have been uploaded on or after the timestamp. The `toTimestamp` parameter will return assets that have been uploaded on or before the timestamp. You can use `fromTimestamp` and `toTimestamp` together. The returned list is in ascending order based on the time of upload.&#x20;

| Name                                      | Type   | Description                                                                                                                             |
| ----------------------------------------- | ------ | --------------------------------------------------------------------------------------------------------------------------------------- |
| key<mark style="color:red;">\*</mark>     | string | Your API key.                                                                                                                           |
| email<mark style="color:red;">\*</mark>   | string | Your email address                                                                                                                      |
| secKey<mark style="color:red;">\*</mark>  | string | Your Secret key. Only if enabled through the [Security page](/web-console/manage-pages/collections-and-sharing/security.md#secret-key). |
| userKey<mark style="color:red;">\*</mark> | string | Your authentication key. You can retrieve your User Key by clicking the Dev Tools icon in the upper right of the echo3D console.        |
| fromTimestamp                             | number | A timestamp expressed in Unix epoch time to the millisecond.                                                                            |
| toTimestamp                               | number | A timestamp expressed in Unix epoch time to the millisecond.                                                                            |

{% tabs %}
{% tab title="200 " %}
{% code fullWidth="true" %}

```json
[
  {
    "id": "d0b8911e-8309-447c-a191-a430fad22496",
    "target": {
      "id": "3e658b98-5da4-4545-a388-aa55a0791760",
      "type": "BRICK_TARGET",
      "holograms": [
        "d59f5bbc-cccd-4ff0-9954-54ee710a3046",
        "d59f5bbc-cccd-4ff0-9954-54ee710a3046"
      ]
    },
    "hologram": {
      "storageID": "8327004e-b136-41ad-ad34-3be15d76e2e1.dae",
      "id": "d59f5bbc-cccd-4ff0-9954-54ee710a3046",
      "type": "MODEL_HOLOGRAM",
      "targetID": "3e658b98-5da4-4545-a388-aa55a0791760",
      "filename": "Cap.dae"
    },
    "sdks": [
      false,
      false,
      false,
      false,
      false,
      false,
      false,
      false,
      false
    ],
    "additionalData": {
      "qrWebXRStorageID": "8f46c128-be98-466b-aa88-c686f8d6084f.png",
      "screenshotStorageID": "4279783e-6ab3-48f1-a8fc-6689eaf29536.png",
      "qrARjsStorageFilename": "qr_arjs.png",
      "qrARjsTargetStorageFilename": "qr_arjs.patt",
      "qrARjsMarkerStorageFilename": "marker_qr_arjs.png",
      "qrARjsTargetStorageID": "8b998c81-f8ea-41e9-b974-3f52eee61898",
      "qrWebARStorageID": "d7b8daeb-98b9-45a5-b37d-c18c0b5ac860.png",
      "createdByEmail": "<EMAIL>",
      "createdAt": "1747340785010",
      "qrWebXRStorageFilename": "qr_webxr.png",
      "aiTags": "[\"Clothing\",\"Hardhat\",\"Helmet\",\"Hat\",\"Cap\"]",
      "topRightType": "ar",
      "usdzHologramStorageFilename": "Cap.usdz",
      "lastUpdatedTimestamp": "1747340790624",
      "topRightText": "See in AR ?",
      "filePath": "null",
      "qrFaceARStorageFilename": "qr_facear.png",
      "bottomRightType": "qr",
      "qrFaceARStorageID": "b84f6ef7-8131-48e8-9742-2ba8cacb665e.png",
      "glbHologramStorageID": "34e2e9db-7c88-4044-8c92-15136e57de8a.glb",
      "usdzHologramStorageID": "b34891af-854f-47e2-b3fb-fd7a9ed4a09c.usdz",
      "qrARjsStorageID": "83bc578f-57b4-4801-9497-fc551010df8a.png",
      "lastUpdatedByEmail": "<EMAIL>",
      "storageUsed": "8643189",
      "fileSize": "4910996",
      "lastAccessed": "1747340785010",
      "qrARjsMarkerStorageID": "3665fda5-2958-48ab-9cfa-33b5ff10c2dc.png",
      "screenshotStorageFilename": "Cap.png",
      "glbHologramStorageFilename": "Cap.glb",
      "qrWebARStorageFilename": "qr_webar.png"
    },
    "checksums": [
      "955528ed067d5d6400ba66a763235ba5"
    ]
  },
  {
    "id": "50d680ec-0893-4371-98f6-0c0e8c789aa3",
    "target": {
      "id": "a758fa33-5793-493e-811e-3815967a715e",
      "type": "BRICK_TARGET",
      "holograms": [
        "44f33faa-ceeb-41eb-a903-c3c36bc771b7",
        "44f33faa-ceeb-41eb-a903-c3c36bc771b7"
      ]
    },
    "hologram": {
      "storageID": "87b265c9-c862-4497-bfb5-b38b8255121a.glb",
      "id": "44f33faa-ceeb-41eb-a903-c3c36bc771b7",
      "type": "MODEL_HOLOGRAM",
      "targetID": "a758fa33-5793-493e-811e-3815967a715e",
      "filename": "armor_all.glb"
    },
    "sdks": [
      false,
      false,
      false,
      false,
      false,
      false,
      false,
      false,
      false
    ],
    "additionalData": {
      "qrWebXRStorageID": "d1db55f9-caf5-40f1-ba69-f241a71614db.png",
      "screenshotStorageID": "0b565683-a2de-4a1d-bd10-4f0d107e1012.png",
      "shortURL": "https://go.echo3d.dev/",
      "qrARjsStorageFilename": "qr_arjs.png",
      "qrARjsTargetStorageFilename": "qr_arjs.patt",
      "qrARjsMarkerStorageFilename": "marker_qr_arjs.png",
      "qrARjsTargetStorageID": "affd2ca3-1dab-4718-9bf9-e236d9672a89",
      "qrWebARStorageID": "cf548e49-04a9-4ef9-93a7-3fb27ae65ec3.png",
      "createdByEmail": "<EMAIL>",
      "createdAt": "1747468270377",
      "qrWebXRStorageFilename": "qr_webxr.png",
      "aiTags": "[\"Bottle\",\"Water Bottle\",\"Shaker\"]",
      "topRightType": "ar",
      "usdzHologramStorageFilename": "armor_all.usdz",
      "lastUpdatedTimestamp": "1747468275670",
      "topRightText": "See in AR ?",
      "filePath": "null",
      "qrFaceARStorageFilename": "qr_facear.png",
      "bottomRightType": "qr",
      "qrFaceARStorageID": "53f109a6-0c46-48af-b785-9c13390b9dc0.png",
      "usdzHologramStorageID": "adda0e8d-9aef-4462-a39c-deb9310d5d5d.usdz",
      "qrARjsStorageID": "239ff656-1348-48ce-81af-506b49ede5a8.png",
      "lastUpdatedByEmail": "<EMAIL>",
      "storageUsed": "20270164",
      "fileSize": "9082380",
      "lastAccessed": "1747468270377",
      "qrARjsMarkerStorageID": "0b4a0ddf-b483-4304-b58f-80e4ec5139c0.png",
      "screenshotStorageFilename": "armor_all.png",
      "qrWebARStorageFilename": "qr_webar.png"
    },
    "checksums": [
      "36920ed56c39a279b32c25fa06d99310"
    ]
  },
  {
    "id": "e5e125a1-5bf2-42ed-9ddb-d702eed9f623",
    "target": {
      "id": "b7b0be5a-c9cf-4638-97b3-80141b495bdb",
      "type": "BRICK_TARGET",
      "holograms": [
        "ff95d7ea-cfcf-463d-b3cb-e39a3bec6a23",
        "ff95d7ea-cfcf-463d-b3cb-e39a3bec6a23"
      ]
    },
    "hologram": {
      "storageID": "346e4c8d-fdfc-4c9b-a8c6-dae1431626a8.glb",
      "id": "ff95d7ea-cfcf-463d-b3cb-e39a3bec6a23",
      "type": "MODEL_HOLOGRAM",
      "targetID": "b7b0be5a-c9cf-4638-97b3-80141b495bdb",
      "filename": "car.glb"
    },
    "sdks": [
      false,
      false,
      false,
      false,
      false,
      false,
      false,
      false,
      false
    ],
    "additionalData": {
      "qrWebXRStorageID": "bac926d5-113b-40a9-b429-a9ca2e90f93d.png",
      "screenshotStorageID": "f1289c68-e0e8-4232-ad49-92ea33545b6e.png",
      "shortURL": "https://go.echo3d.dev/",
      "qrARjsStorageFilename": "qr_arjs.png",
      "qrARjsTargetStorageFilename": "qr_arjs.patt",
      "qrARjsMarkerStorageFilename": "marker_qr_arjs.png",
      "qrARjsTargetStorageID": "95699a9c-3786-488c-88c1-622c41955907",
      "qrWebARStorageID": "db4ba9f7-5f6f-4bb5-a37f-c0443b476dca.png",
      "createdByEmail": "<EMAIL>",
      "createdAt": "1747554134022",
      "qrWebXRStorageFilename": "qr_webxr.png",
      "aiTags": "[\"Car\",\"Transportation\",\"Vehicle\",\"Sports Car\"]",
      "topRightType": "ar",
      "usdzHologramStorageFilename": "car.usdz",
      "lastUpdatedTimestamp": "1747554153270",
      "topRightText": "See in AR ?",
      "filePath": "null",
      "qrFaceARStorageFilename": "qr_facear.png",
      "bottomRightType": "qr",
      "qrFaceARStorageID": "54ce3962-76d1-4532-95ca-e208c8f7adf5.png",
      "usdzHologramStorageID": "76682589-51b2-454b-a2c0-ba1fb3b74380.usdz",
      "qrARjsStorageID": "403df553-91a7-4f6f-bdf3-3045cf5132fb.png",
      "lastUpdatedByEmail": "<EMAIL>",
      "storageUsed": "43273937",
      "fileSize": "15511940",
      "lastAccessed": "1747554134022",
      "qrARjsMarkerStorageID": "780b4126-0abc-476a-a7c9-7de0eb6d9f25.png",
      "screenshotStorageFilename": "car.png",
      "qrWebARStorageFilename": "qr_webar.png"
    },
    "checksums": [
      "56c49ea5bdb34c233693973a93725a87"
    ]
  }
]
```

{% endcode %}
{% endtab %}

{% tab title="400 - fromTimestamp parse error" %}
{% code overflow="wrap" %}

```
'fromTimestamp' parameter received cannot be parsed as a number. Epoch time in milliseconds expected.
```

{% endcode %}
{% endtab %}

{% tab title="400 - toTimestamp parse error" %}
{% code overflow="wrap" %}

```
'toTimestamp' parameter received cannot be parsed as a number. Epoch time in milliseconds expected.
```

{% endcode %}
{% endtab %}
{% endtabs %}

## Get entries based on location

<mark style="color:blue;">`GET`</mark> `https://api.echo3D.com/query?key=<API_KEY>&email=<EMAIL>&userKey=<USER_KEY>&location=<LAT>,<LONG>&radius=<RADIUS>`

#### Query Parameters

| Name                                       | Type   | Description                                                                                                                                     |
| ------------------------------------------ | ------ | ----------------------------------------------------------------------------------------------------------------------------------------------- |
| key<mark style="color:red;">\*</mark>      | string | Your API key.                                                                                                                                   |
| location<mark style="color:red;">\*</mark> | string | A pair of GPS coordinates in the form of LAT,LONG or a location name that will be converted to GPS coordinates.                                 |
| radius                                     | string | The acceptable distance in miles between the location and the the entry's location. If radius isn't specified, a default 1 mile radius is used. |
| secKey                                     | string | Your Secret key. Only if enabled through the [Security page](/web-console/manage-pages/collections-and-sharing/security.md#secret-key).         |
| email<mark style="color:red;">\*</mark>    | string | Your email address                                                                                                                              |
| userKey<mark style="color:red;">\*</mark>  | string | Your authentication key                                                                                                                         |

{% tabs %}
{% tab title="200 " %}

```json
{
  "apiKey": "<API_KEY>",
  "db": {
    "62714211-a573-40ab-9ae2-d2c9aff68c5a": {
      "id": "62714211-a573-40ab-9ae2-d2c9aff68c5a",
      "target": {
        "place": "New York",
        "latitude": 40.776653,
        "longitude": -73.9547,
        "id": "c1cc0e59-3294-459e-a7ce-a9d14cf2dbdd",
        "type": "GEOLOCATION_TARGET",
        "holograms": [
          "038ecebe-9d81-4a3b-aa8b-f33fbf0e1a1b"
        ]
      },
      "hologram": {
        "filename": "Skyscraper.obj",
        "storageID": "d686a655-e800-430d-bfd2-e38cdfb0c9e9",
        "textureFilenames": [
          "Skyscraper_BaseColor.png"
        ],
        "textureStorageIDs": [
          "f9b43711-cf79-44e5-90c5-ac781c8d9288"
        ],
        "materialFilename": "Skyscraper.mtl",
        "materialStorageID": "891d0b32-4f4b-4f7d-a2e2-d5922611928d",
        "id": "038ecebe-9d81-4a3b-aa8b-f33fbf0e1a1b",
        "type": "MODEL_HOLOGRAM",
        "targetID": "c1cc0e59-3294-459e-a7ce-a9d14cf2dbdd"
      },
      "sdks": [
        true,
        true,
        false,
        true,
        false,
        false,
        false,
        true,
        true
      ],
      "additionalData": {
        "vuforiaHologramStorageID": "7068cd74-6c9f-4106-9326-585c56fa4475",
        "glbHologramStorageID": "d686a655-e800-430d-bfd2-e38cdfb0c9e9.glb",
        "source": "Skyscraper by Poly by Google, CC-BY, https://poly.google.com/view/dIsZyy2FUY-",
        "qrARjsTargetStorageID": "e7f058d5-5b66-4f50-8cdd-89f057e8070c",
        "qrARjsStorageID": "7cc6adca-ded1-4a46-a289-c07c07cb2f5c",
        "vuforiaHologramStorageFilename": "Skyscraper.h",
        "qrARjsMarkerStorageID": "5de99f4d-9602-45f0-b5ce-7ef53541cb18",
        "glbHologramStorageFilename": "Skyscraper.glb"
      }
    }
  }
}
```

{% endtab %}

{% tab title="400 " %}

```
No entires located '<RADUIS>' miles around '<LAT,LONG>' associated with key '<API_KEY>'
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.echo3d.com/api/queries.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
